
//+------------------------------------------------------------------+
//|                                               ZigZag_2.mq4 |
//|                        Copyright 2022, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2
//--- plot UP
#property indicator_label1  "UP"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  5
//--- plot DN
#property indicator_label2  "DN"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrDodgerBlue
#property indicator_style2  STYLE_SOLID
#property indicator_width2  5
//--- input parameters
input int      Depth = 12;
input int      Deviation = 5;
input int      Backstep = 3;
//--- indicator buffers
double         UP[];
double         DN[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
//--- indicator buffers mapping
   SetIndexBuffer(0, UP);
   SetIndexBuffer(1, DN);
//--- setting a code from the Wingdings charset as the property of PLOT_ARROW
   SetIndexArrow(0, 233);
   SetIndexArrow(1, 234);

//---
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
//---
   int limit = Bars - prev_calculated - 1;

   int min = 1;

   if (prev_calculated > 0) {
      int count = 0;
      for (int i = 1; i < Bars - 1; i++) {
         double zz = iCustom(NULL, 0, "ZigZag", Depth, Deviation, Backstep, 0, i);
         if (zz != 0) count++;
         if (count >= 3) {
            min = i;
            break;
         }
      }
   }

   if (limit < min) limit = min;

   double point[4];
   int bar[4];
   int n = 0;

   for (int i = limit; i >= 0; i--) {
      double zz = iCustom(NULL, 0, "ZigZag", Depth, Deviation, Backstep, 0, i);
      if (zz != 0) {
         ArrayInitialize(point, 0);
         ArrayInitialize(bar, 0);
         point[0] = zz;
         bar[0] = i;
         n = 1;
         for (int j = i + 1; j < Bars - 1; j++) {
            zz = iCustom(NULL, 0, "ZigZag", Depth, Deviation, Backstep, 0, j);
            if (zz != 0) {
               point[n] = zz;
               bar[n] = j;
               n++;
            }
            if (n >= 4) break;
         }
         if (n >= 4) {
            if (point[0] == High[bar[0]] && point[0] > point[2] && point[3] < point[1]) {
               for (int k = i - 1; k >= 0; k--) {
                  if (Low[k] < point[0]) {
                     DN[k] = High[k];
                     break;
                  } else DN[k] = EMPTY_VALUE;
                  zz = iCustom(NULL, 0, "ZigZag", Depth, Deviation, Backstep, 0, k);
                  if (zz != 0) break;
               }
            }
            if (point[0] == Low[bar[0]] && point[0] < point[2] && point[3] > point[1]) {
               for (int k = i - 1; k >= 0; k--) {
                  if (High[k] > point[0]) {
                     UP[k] = Low[k];
                     break;
                  } else UP[k] = EMPTY_VALUE;
                  zz = iCustom(NULL, 0, "ZigZag", Depth, Deviation, Backstep, 0, k);
                  if (zz != 0) break;
               }
            }
         }
      }
   }
//--- return value of prev_calculated for next call
   return(rates_total);
}
